Attribute VB_Name = "modMain"
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal Hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long
Declare Function PathFileExists Lib "shlwapi.dll" Alias "PathFileExistsA" (ByVal pszPath As String) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Const Desktop = &H0
Const Temporary = &H1
Const Programs = &H2
Const Windows = &H3
Const System = &H4
Const Documents = &H5
Const Favorites = &H6
Const StartUp = &H7
Const Recent = &H8
Const SendTo = &H9
Const DesktopDirectory = &H10
Const StartMenu = &HB
Const NetHood = &H13
Const Fonts = &H14
Const ShellNew = &H15
Const AllUsersDektop = &H19
Const Cookies = &H21
Const History = &H22
Const TemporaryInternetFiles = &H20
Const ProgramFiles = &H26
Const Media = &H27
Const Common = &H28
Const Config = &H29
Const Device = &H30

Type SHITEMID
    cb                As Long
    abID              As Byte
End Type

Type ITEMIDLIST
    mkid              As SHITEMID
End Type
    
Public maxW                  As Integer 'sirina progress bara (shape)
Dim OK                       As Boolean 'True - ako su svi property upisani
Private PropBag              As New PropertyBag 'ovde se nalaze properties
Private zipFile              As String 'sadrzaj zip-a
Private dllFile              As String 'sadrzaj dll-a (aunzip.dll)
Private cfgFile              As String 'sadrzaj ini-ja
Private fileCount            As Integer 'broj fajlova
Private curFile              As Integer 'broj fajla koji se unzipuje (1-fileCount)
Private Run()                As String 'sadrzi fajlove koji ce biti pokrenuti
'podesava progress bar
Public Sub setProgress(ByVal Value As Integer) '0-100
    If (Value > 100) Then Value = 100
    If (Value < 0) Then Value = 0
    Value = Round(Value, 0)
    With frmProgress
        .shpPropgress.Width = (Value / 100) * maxW
        .lblProgress = Value & "%"
        'progress label:
        .lblProgress.Left = .shpPropgress.Width - .lblProgress.Width + 5
        .lblInfo.Caption = getProgress & "%"
        DoEvents
    End With
End Sub
'vraca vrednost(value)progress bar-a
Public Function getProgress() As Integer '0-100
    getProgress = Round((frmProgress.shpPropgress.Width / maxW) * 100, 0)
End Function
Public Sub InfoChanged(newinfo As String) 'info koji aunzip32.dll salje u txtReciver
    Dim file As String, percent As String, action As String
    
    file = GetFileName(newinfo) 'ime fajla koji se trenutno raspakuje
    percent = GetPercentComplete(newinfo) 'procenat (0-100)
    action = Akcija(Val(getAction(newinfo))) 'akcija
    
    If (action <> "Greka") Then
        If (frmProgress.lblInfo.Caption <> file) Then frmProgress.lblInfo.Caption = file
        setProgress CInt((curFile - 1) / fileCount * 100) + _
                    CInt(CInt(percent) / fileCount)
        If (action = "Raspakovano") Then curFile = curFile + 1
    End If
End Sub
Public Sub Main()
    Load frmProgress
    With frmProgress
        maxW = .shpPropgress.Width
        .shpPropgress.Width = 0 'min
    End With
    
    If FolderExists(tempPath) = True Then
        On Error Resume Next
        Kill tempPath & "\*.*"
    Else
        MkDir tempPath
    End If

    Call readME 'citamo sta je upisano u exe (znaci zip, cfgs i dll)
    
    Call PrikaciMe(frmProgress, frmProgress.txtReciver) 'instaliramo aunzip32.dll
    
    Call writeINI(cfgFile) 'generisemo INI fajl ([K]Installer.INI)
    
    DoEvents
    Sleep 100
    
    If (GetINI("Config", "Progres", "1", tempPath & "[K]Installer.ini") = "1") Then
        frmProgress.Show 'pokazi progress bar
    End If
    
    frmProgress.lblAction.Caption = "Extracting..."
    Call Raspakuj(tempPath & "\[K]Installer.zip", tempPath) 'raspakujemo celu arhivu
    
    frmProgress.lblAction.Caption = "Copying..."
    Call Sortiraj 'slazemo fajlove po datim folderima
    
    Sleep 100
    Call AppUnload(1)  'EXIT ! :o)
End Sub
Sub readME()
    On Error GoTo errh
    
    Dim BeginPos   As Long
    Dim varTemp    As Variant
    Dim byteArr()  As Byte
    Dim fn         As Integer
    
    fn = FreeFile
    Open App.Path & "\" & App.EXEName & ".exe" For Binary As #fn
        Get #1, LOF(fn) - 3, BeginPos    'sa ove pozicije citamo podatke
        Seek #1, BeginPos
        Get #1, , varTemp               'citamo podatke

        byteArr = varTemp
        PropBag.Contents = byteArr      'upisujemo ih u property bag
    Close #fn


    With PropBag 'podesavamo vrednosti:
        cfgFile = .ReadProperty("cfgFile", vbNullString)
        zipFile = .ReadProperty("zipFile", vbNullString)
        dllFile = .ReadProperty("dllFile", vbNullString)
    End With
     
    'ako nema bar jednog od potrebnog propertija - izadji
    If (zipFile = "") Or (dllFile = "") Or (cfgFile = "") Then AppUnload 0
    
    If (FileExists(GetSpecialFolder(System) & "\aunzip32.dll") = False) Then
        'dll ne postoji na kompu - treba da ga "instaliramo"
        fn = FreeFile
        Open GetSpecialFolder(System) & "\aunzip32.dll" For Output As #fn
            Print #fn, dllFile
        Close #fn
        'to je to - dll je instaliran! :o)
    End If
    
    If (FileExists(tempPath & "[K]Installer.zip") = True) Then Kill tempPath & "[K]Installer.zip"
    
    fn = FreeFile
    Open tempPath & "[K]Installer.zip" For Output As #fn
        Print #fn, zipFile  '"kreiramo" zip fajl
    Close #fn
    
    If (FileExists(tempPath & "[K]Installer.INI") = True) Then Kill tempPath & "[K]Installer.INI"
    
    
    OK = True 'sve je u redu
    Exit Sub
errh:
    OK = False
    AppUnload 0
End Sub
Sub Sortiraj()
    Dim sFile() As String, i As Integer, mv As Integer
    Dim tmp As String
    
    With frmProgress.File1 'uzimamo sve fajlove iz foldera(temp)...
        .Path = tempPath
        .Pattern = "*.*"
        .Hidden = True
        .ReadOnly = True
        .System = True
        For i = 0 To .ListCount - 1
            If .List(i) <> "[K]Installer.ini" And .List(i) <> "[K]Installer.zip" Then
                ReDim Preserve sFile(i) As String
                sFile(i) = .List(i) 'prvo punimo array
            End If
        Next
    End With
    
    setProgress 0
    mv = UBound(sFile)
    For i = LBound(sFile) To mv 'sad citamo fajl po fajl
        On Error Resume Next 'za svaki slucaj!
        tmp = GetINI(sFile(i), "Folder", "", tempPath & "[K]Installer.ini")
        tmp = readPath(tmp) 'menjamo konstante
        makeFolder tmp 'kreiramo folder ako ne postoji
        frmProgress.lblInfo.Caption = sFile(i)
        FileCopy tempPath & sFile(i), tmp & sFile(i) 'kopiramo fajl!
        setProgress (i / mv) * 100
        'run
        If (GetINI(sFile(i), "Run", "0", tempPath & "[K]Installer.ini") = "2") Then
            ShellExecute frmProgress.Hwnd, "Open", tmp & sFile(i), "", tmp, 1
        End If
        DoEvents
    Next
    
End Sub
Sub writeINI(inicontents As String)
    Dim ary() As String, tmp As String, fn As Integer, i As Integer
    Dim files As String, entry() As String, r As Integer
    
    fn = FreeFile
    ary = Split(inicontents, "config.end", , vbTextCompare) ' [Config]
    tmp = ary(0) 'npr. 12|1 - prvi broj:broj fajlova, drugi broj:show progress (0/1)
    files = ary(1) 'fajlovi

    Open tempPath & "[K]Installer.ini" For Output As #fn
        
        ary = Split(tmp, "|")
        Print #fn, "[Config]"
        Print #fn, "Ukupno=" & ary(0) ' broj fajlova upakovanih u zipu
        Print #fn, "Progres=" & ary(1) '1/0
        fileCount = CInt(ary(1))
        
        ary = Split(files, "file.end", , vbTextCompare)
        For i = LBound(ary) To UBound(ary)
            If (InStr(1, ary(i), "|") <= 0) Then GoTo jump
            entry = Split(ary(i), "|") ' filename|folder|run
            Print #fn, "[" & entry(0) & "]" 'filetitle
            Print #fn, "Folder=" & entry(1) 'dir u koji fajl treba da bude kopiran
            Print #fn, "Run=" & entry(2)
            r = CInt(entry(2)) 'run parametar
            If (r = 1) Then
                r = UBound(Run) + 1
                ReDim Preserve Run(r) 'uvecavamo array (+1)
                Run(r) = readPath(entry(1)) & "\" & entry(0) 'cuvamo podatak
            End If
            'Run parametar (moze biti pokrenut bilo koji fajl a ne samo .exe):
            '0 - ne pokreci ovaj fajl
            '1 - pokreni fajl kada se instalacija zavrsi
            '2 - pokreni fajl kada se iskopira u odredisni folder
            'upotrebu parametra 2 ne preporucujem :D
jump:
        Next
        DoEvents
    Close #fn
    Sleep 1000
End Sub
Sub AppUnload(everythingIsOK As Integer)
On Error GoTo errh
    If Not everythingIsOK Then GoTo errh 'greska
    
    Dim r As Integer
    For r = LBound(Run) To UBound(Run) 'pokrecemo sve sto ima Run=1 parametar
        ShellExecute frmProgress.Hwnd, "Open", Run(r), vbNullString, getpath(Run(r)), 1
    Next
errh:
    On Error Resume Next
    Unload frmProgress
    Kill tempPath & "\*.*"
    RmDir tempPath
    End
End Sub
'cita INI fajl
Function GetINI(lpAppName$, lpKeyName$, lpDefault, lpFileName$)
    Dim lpReturnString$, nSize%, Valid%
    lpReturnString$ = Space$(128)
    nSize% = Len(lpReturnString$)
    Valid% = GetPrivateProfileString(ByVal lpAppName$, ByVal lpKeyName$, ByVal lpDefault, ByVal lpReturnString$, ByVal nSize%, ByVal lpFileName$)
    GetINI = Left$(lpReturnString$, Valid%)
End Function
Function tempPath() As String 'putanja do temp foldera u koji cemo da unzipujemo
    tempPath = GetSpecialFolder(Temporary) & "\[K]\"
End Function
Function getpath(fullpath As String)
    '"cupa" folder iz filename-a
    getpath = Mid$(fullpath, 1, InStrRev(fullpath, "\"))
End Function
Function readPath(sPath As String) As String 'zamenjuje konstante
    readPath = Replace(sPath, "%desktop%", GetSpecialFolder(Desktop), , , 1)
    readPath = Replace(readPath, "%temp%", GetSpecialFolder(Temporary), , , 1)
    readPath = Replace(readPath, "%programs%", GetSpecialFolder(Programs), , , 1)
    readPath = Replace(readPath, "%windows%", GetSpecialFolder(Windows), , , 1)
    readPath = Replace(readPath, "%system%", GetSpecialFolder(System), , , 1)
    readPath = Replace(readPath, "%documents%", GetSpecialFolder(Documents), , , 1)
    readPath = Replace(readPath, "%favorites%", GetSpecialFolder(Favorites), , , 1)
    readPath = Replace(readPath, "%startup%", GetSpecialFolder(StartUp), , , 1)
    readPath = Replace(readPath, "%recent%", GetSpecialFolder(Recent), , , 1)
    readPath = Replace(readPath, "%sendto%", GetSpecialFolder(SendTo), , , 1)
    readPath = Replace(readPath, "%desktopdirectory%", GetSpecialFolder(DesktopDirectory), , , 1)
    readPath = Replace(readPath, "%startmenu%", GetSpecialFolder(StartMenu), , , 1)
    readPath = Replace(readPath, "%nethood%", GetSpecialFolder(NetHood), , , 1)
    readPath = Replace(readPath, "%fonts%", GetSpecialFolder(Fonts), , , 1)
    readPath = Replace(readPath, "%shellnew%", GetSpecialFolder(ShellNew), , , 1)
    readPath = Replace(readPath, "%allusersdesktop%", GetSpecialFolder(AllUsersDektop), , , 1)
    readPath = Replace(readPath, "%cookies%", GetSpecialFolder(Cookies), , , 1)
    readPath = Replace(readPath, "%history%", GetSpecialFolder(History), , , 1)
    readPath = Replace(readPath, "%temporaryinternetfiles%", GetSpecialFolder(TemporaryInternetFiles), , , 1)
    readPath = Replace(readPath, "%programfiles%", GetSpecialFolder(ProgramFiles), , , 1)
    readPath = Replace(readPath, "%media%", GetSpecialFolder(Media), , , 1)
    readPath = Replace(readPath, "%config%", GetSpecialFolder(Config), , , 1)
    readPath = Replace(readPath, "%device%", GetSpecialFolder(Device), , , 1)
    If Right$(readPath, 1) = "\" Then readPath = Left$(readPath, Len(readPath) - 1)
    readPath = Replace(readPath, "\\", "\") 'za svaki slucaj...
End Function
Function GetSpecialFolder(ByVal Folder As Long) As String
    Dim r    As Long
    Dim IDL  As ITEMIDLIST
    Dim ret  As String
    Dim regy As clsRegistryAccess
    
    Set regy = New clsRegistryAccess
    
    If (Folder = System) Then
        ret = Space(255)
        r = GetSystemDirectory(ret, 255)
        ret = Left$(ret, r)
    ElseIf (Folder = Temporary) Then
        ret = String(100, Chr$(0))
        GetTempPath 100, ret
        ret = Left$(ret, InStr(ret, Chr$(0)) - 1)
    ElseIf (Folder = Windows) Then
        ret = String(200, Chr$(0))
        r = GetWindowsDirectory(ret, Len(ret))
        ret = Left$(ret, r)
    ElseIf (Folder = ProgramFiles) Then
        ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "ProgramFilesDir", "C:\Program files")
    ElseIf (Folder = Media) Then
        ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "MediaPath", "C:\WINDOWS\media")
    ElseIf (Folder = Config) Then
        ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "ConfigPath", "C:\WINDOWS\config")
    ElseIf (Folder = Common) Then
        ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "CommonFilesDir", "C:\Program files\Common Files")
    ElseIf (Folder = Device) Then
        ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "DevicePath", "C:\WINDOWS\INF")
    Else
        r = SHGetSpecialFolderLocation(100, Folder, IDL)
        If r = NOERROR Then
            Path$ = Space$(512)
            r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal Path$)
            ret = Left$(Path, InStr(Path, Chr$(0)) - 1)
        Else
            ret = ""
        End If
    End If
    
    Set regy = Nothing
    If (Right$(ret, 1) = "\") Then ret = Left$(ret, Len(ret) - 1) 'bez "\" na kraju!
    GetSpecialFolder = ret
End Function
'pravi folder tako sto pravi sve potrebne foldere iz putanje
Public Sub makeFolder(ByVal folderpath As String)
On Error GoTo errh:
    Dim pathArry() As String, i As Integer, bPath As String
    Dim strTmp As String, mDir As String
    
    pathArry = Split(folderpath, "\")
    
    For i = LBound(pathArry) To UBound(pathArry)
    
        strTmp = pathArry(i)
        
        If (Len(strTmp) = 2) And (Mid(strTmp, 2, 1) = ":") Then
            bPath = strTmp & "\" 'drive
            GoTo jump
        End If
        
        mDir = bPath & strTmp
        
        If (FolderExists(mDir) = False) Then MkDir mDir
        
        bPath = mDir & "\"
jump:
    Next
    
    If Right$(folderpath, 1) <> "\" Then folderpath = folderpath & "\"
    
    Exit Sub
errh:
MsgBox "Error creating folder:" & vbCrLf & _
        folderpath, vbExclamation, "Error!"
        AppUnload 0
End Sub
Function FolderExists(folderpath As String) As Boolean
    FolderExists = CBool(PathIsDirectory(folderpath))
End Function
Function FileExists(filepath As String) As Boolean
    FileExists = CBool(PathFileExists(filepath))
End Function
